<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglCommunication.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_d89ec3ddd84898ed9313f7a84ea735df.html">communication</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglCommunication.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglCommunication_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLCOMMUNICATION_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLCOMMUNICATION_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include  &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &lt;mpi.h&gt;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"> * typedefs/Macros</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#if !defined(_MPI)</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">// dummy definitions for consistency</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">typedef</span> <span class="keywordtype">int</span> MPI_Request;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">typedef</span> <span class="keywordtype">int</span> MPI_Status;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#define MAX_MESSAGE_SIZE                   32768//2048//2048</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#define MPI_DATA_MESSAGE_TAG                  10</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="preprocessor">#define MPI_SYSTEM_MESSAGE_TAG             11</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="preprocessor">#define MPI_MUTATION_MESSAGE_TAG           12</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="preprocessor">#define MPI_DEV_MESSAGE_COUNT_TAG          13</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="preprocessor">#define  UNKNOWN_DEV                       -1</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="preprocessor">#define NONBLOCKING_RX_THREADS             16//64 // number of concurrent nonblocking mpi read</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="preprocessor">#define NONBLOCKING_TX_THREADS             16//64 // number of concurrent nonblocking mpi read</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="preprocessor">#define NONBLOCKING_MUTATATION_BUILD_FLAG  0</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment"> * general communication routines</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;int_fast32_t <a class="code" href="group__comm__routines.html#gae2623e3f83f9c72f406cfd93f6156348">TIGLCommunicationFindDevice</a>(uint_fast32_t vtxID, uint_fast32_t totalNumVertices, uint_fast32_t numDevices);</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">// Rx routines</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__comm__routines.html#ga263c63472be6e732331906559a138021">TIGLCommunicationRecvMPICommand</a>(uint8_t *rxBuf, uint_fast32_t bufSize, int_fast32_t src);</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;int_fast32_t <a class="code" href="group__comm__routines.html#ga263c63472be6e732331906559a138021">TIGLCommunicationRecvMPICommand</a>(uint8_t *rxBuf, uint_fast32_t bufSize, int_fast32_t src, <span class="keywordtype">int</span> tag);</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__comm__routines.html#ga263c63472be6e732331906559a138021">TIGLCommunicationRecvMPICommand</a>(uint8_t *rxBuf, int_fast32_t *numMessageuint8_ts);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;int_fast32_t <a class="code" href="group__comm__routines.html#gad699725401268bd630f50e0a38823ee4">TIGLCommunicationRecvTaggedMPICommand</a>(uint8_t *rxBuf, <span class="keywordtype">int</span> tag);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;int_fast32_t <a class="code" href="group__comm__routines.html#gaee85762f67e58df275a10d7bececf940">TIGLCommunicationRecvTaggedMPICommandfromDev</a>(uint8_t *rxBuf, <span class="keywordtype">int</span> tag, <span class="keywordtype">int</span> dev, <span class="keywordtype">int</span> count);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__comm__routines.html#ga131d1cc990db51906a3ea9b1b5cf5c1b">TIGLCommunicationRecvMPICommandNonblocking</a>(uint8_t *rxBuf, MPI_Request *req);</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__comm__routines.html#ga131d1cc990db51906a3ea9b1b5cf5c1b">TIGLCommunicationRecvMPICommandNonblocking</a>(uint8_t *rxBuf, <span class="keywordtype">int</span> messageSize, <span class="keywordtype">int</span> dev, <span class="keywordtype">int</span> tag, MPI_Request *req);</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">// Tx routines</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__comm__routines.html#ga4fc5e84dbbe91a83f9e9d1a2d5144151">TIGLCommunicationSendMPICommand</a>(uint8_t *txBuf, uint_fast32_t bufSize, int_fast32_t dst, <span class="keywordtype">int</span> tag);</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__comm__routines.html#ga55203f293cf194bc1dde2803bdb77bb6">TIGLCommunicationSendMPICommandNonblocking</a>(uint8_t *txBuf, uint_fast32_t bufSize, int_fast32_t dst, <span class="keywordtype">int</span> tag, MPI_Request *req);</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="comment">// monitoring routines</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#ga23cfdef6309f15a92a5a79ff1d4e77d8">TIGLCommunicationExistMutationMessages</a>();</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#gadf306c4991fc833186b65c8700815f74">TIGLCommunicationExistMessages</a>();</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#gadf306c4991fc833186b65c8700815f74">TIGLCommunicationExistMessages</a>(<span class="keywordtype">int</span> *tag, <span class="keywordtype">int</span> *dev, <span class="keywordtype">int</span> *messageSize);</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#gae9386ff69f95193aaeb3f10199979d07">TIGLCommunicationExistMessagesFromDev</a>(uint_fast32_t dev);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#gab848bd17d1170ed31806edb6bea1bd0c">TIGLCommunicationExistMessagesWithTag</a>(<span class="keywordtype">int</span> tag);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#gab922207328e48b4acef99280809a1475">TIGLCommunicationExistTaggedMessageFromDev</a>(<span class="keywordtype">int</span> tag, uint_fast32_t dev, int_fast32_t *messageSize);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__comm__routines.html#ga98daaa3a6811aa132b3eef033f518d40">TIGLCommunicationWaitMPINonblocking</a>(MPI_Request *req);</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#gad6e0b7c20af66cc9645315b1431c5274">TIGLCommunicationTestMPINonblocking</a>(MPI_Request *req, <span class="keywordtype">int</span> *tag, <span class="keywordtype">int</span> *messageSize);</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__comm__routines.html#gad6e0b7c20af66cc9645315b1431c5274">TIGLCommunicationTestMPINonblocking</a>(MPI_Request *req);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment"> * TIGLCommunicationMessageDev structure</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html">  116</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structTIGLCommunicationMessageDev.html">TIGLCommunicationMessageDev</a></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;{</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#a0ea7da2bd0e063ebc4572796f3bb7b0d">  124</a></span>&#160;   uint8_t <a class="code" href="structTIGLCommunicationMessageDev.html#a0ea7da2bd0e063ebc4572796f3bb7b0d">buf</a>[MAX_MESSAGE_SIZE];</div>
<div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#ae6b08d70daac37e7268197eedc3c711d">  126</a></span>&#160;   uint_fast32_t <a class="code" href="structTIGLCommunicationMessageDev.html#ae6b08d70daac37e7268197eedc3c711d">accMessageSize</a>;</div>
<div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#a3647d597dc8f1678971485b7b8086279">  128</a></span>&#160;   uint_fast32_t <a class="code" href="structTIGLCommunicationMessageDev.html#a3647d597dc8f1678971485b7b8086279">numTx</a>;</div>
<div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#a02805f910460aa8cb91e81003089b045">  130</a></span>&#160;   uint_fast32_t <a class="code" href="structTIGLCommunicationMessageDev.html#a02805f910460aa8cb91e81003089b045">numSysTx</a>;</div>
<div class="line"><a name="l00132"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#a90a38748ce1f33da1b9cc1b097e8e106">  132</a></span>&#160;   uint_fast32_t <a class="code" href="structTIGLCommunicationMessageDev.html#a90a38748ce1f33da1b9cc1b097e8e106">numMutationTx</a>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="comment">    * Methods</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#abce41176d7b2808b745c94d99f542c63">  145</a></span>&#160;   <a class="code" href="structTIGLCommunicationMessageDev.html#abce41176d7b2808b745c94d99f542c63">TIGLCommunicationMessageDev</a>()</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;   {</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;      this-&gt;<a class="code" href="structTIGLCommunicationMessageDev.html#af192ef0016b471e4a3641792f64f2a03">reset</a>();</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;   }</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00155"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#af192ef0016b471e4a3641792f64f2a03">  155</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="structTIGLCommunicationMessageDev.html#af192ef0016b471e4a3641792f64f2a03">reset</a>()</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;   {</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;      <a class="code" href="structTIGLCommunicationMessageDev.html#ae6b08d70daac37e7268197eedc3c711d">accMessageSize</a> = 0;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      <a class="code" href="structTIGLCommunicationMessageDev.html#a3647d597dc8f1678971485b7b8086279">numTx</a> = 0;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      <a class="code" href="structTIGLCommunicationMessageDev.html#a02805f910460aa8cb91e81003089b045">numSysTx</a> = 0;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;      <a class="code" href="structTIGLCommunicationMessageDev.html#a90a38748ce1f33da1b9cc1b097e8e106">numMutationTx</a> = 0;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;   }</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00168"></a><span class="lineno"><a class="line" href="structTIGLCommunicationMessageDev.html#a15fe6bbdde044cfa327721345a294b8e">  168</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="structTIGLCommunicationMessageDev.html#a15fe6bbdde044cfa327721345a294b8e">getMessageCount</a>()</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;   {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;      <span class="keywordflow">return</span> <a class="code" href="structTIGLCommunicationMessageDev.html#a3647d597dc8f1678971485b7b8086279">numTx</a> + <a class="code" href="structTIGLCommunicationMessageDev.html#a02805f910460aa8cb91e81003089b045">numSysTx</a> + <a class="code" href="structTIGLCommunicationMessageDev.html#a90a38748ce1f33da1b9cc1b097e8e106">numMutationTx</a>;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;   }</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;} <a class="code" href="structTIGLCommunicationMessageDev.html">TIGLCommunicationMessageDev</a>;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunicationManager_8hpp.html">tiglCommunicationManager.hpp</a>&quot;</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunicationSysMessage_8hpp.html">tiglCommunicationSysMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLCOMMUNICATION_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="group__comm__routines_html_ga4fc5e84dbbe91a83f9e9d1a2d5144151"><div class="ttname"><a href="group__comm__routines.html#ga4fc5e84dbbe91a83f9e9d1a2d5144151">TIGLCommunicationSendMPICommand</a></div><div class="ttdeci">int TIGLCommunicationSendMPICommand(uint8_t *txBuf, uint_fast32_t bufSize, int_fast32_t dst, int tag)</div><div class="ttdoc">Sends a single message to a particular destination with a given tag. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationTx.cpp:56</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_ae6b08d70daac37e7268197eedc3c711d"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#ae6b08d70daac37e7268197eedc3c711d">TIGLCommunicationMessageDev::accMessageSize</a></div><div class="ttdeci">uint_fast32_t accMessageSize</div><div class="ttdoc">accumulative size in buf </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:126</div></div>
<div class="ttc" id="group__comm__routines_html_ga131d1cc990db51906a3ea9b1b5cf5c1b"><div class="ttname"><a href="group__comm__routines.html#ga131d1cc990db51906a3ea9b1b5cf5c1b">TIGLCommunicationRecvMPICommandNonblocking</a></div><div class="ttdeci">int TIGLCommunicationRecvMPICommandNonblocking(uint8_t *rxBuf, MPI_Request *req)</div><div class="ttdoc">Receives a message with any tag from any source. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationRx.cpp:126</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_a15fe6bbdde044cfa327721345a294b8e"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#a15fe6bbdde044cfa327721345a294b8e">TIGLCommunicationMessageDev::getMessageCount</a></div><div class="ttdeci">uint_fast32_t getMessageCount()</div><div class="ttdoc">returns the total number of messages of all types </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:168</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_a90a38748ce1f33da1b9cc1b097e8e106"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#a90a38748ce1f33da1b9cc1b097e8e106">TIGLCommunicationMessageDev::numMutationTx</a></div><div class="ttdeci">uint_fast32_t numMutationTx</div><div class="ttdoc">accumulative number of mutation message transmissions </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:132</div></div>
<div class="ttc" id="group__comm__routines_html_gad6e0b7c20af66cc9645315b1431c5274"><div class="ttname"><a href="group__comm__routines.html#gad6e0b7c20af66cc9645315b1431c5274">TIGLCommunicationTestMPINonblocking</a></div><div class="ttdeci">bool TIGLCommunicationTestMPINonblocking(MPI_Request *req, int *tag, int *messageSize)</div><div class="ttdoc">Tests the status nonblocking tx/rx and return the tag and message size. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMonitor.cpp:212</div></div>
<div class="ttc" id="group__comm__routines_html_gae2623e3f83f9c72f406cfd93f6156348"><div class="ttname"><a href="group__comm__routines.html#gae2623e3f83f9c72f406cfd93f6156348">TIGLCommunicationFindDevice</a></div><div class="ttdeci">int_fast32_t TIGLCommunicationFindDevice(uint_fast32_t vtxID, uint_fast32_t totalNumVertices, uint_fast32_t numDevices)</div><div class="ttdoc">Computes the owner device of a vertex. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationFindDev.cpp:54</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_af192ef0016b471e4a3641792f64f2a03"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#af192ef0016b471e4a3641792f64f2a03">TIGLCommunicationMessageDev::reset</a></div><div class="ttdeci">void reset()</div><div class="ttdoc">resetting all counters </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:155</div></div>
<div class="ttc" id="group__comm__routines_html_ga23cfdef6309f15a92a5a79ff1d4e77d8"><div class="ttname"><a href="group__comm__routines.html#ga23cfdef6309f15a92a5a79ff1d4e77d8">TIGLCommunicationExistMutationMessages</a></div><div class="ttdeci">bool TIGLCommunicationExistMutationMessages()</div><div class="ttdoc">Check if there exist messages from any source with any tag. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMonitor.cpp:53</div></div>
<div class="ttc" id="group__comm__routines_html_gaee85762f67e58df275a10d7bececf940"><div class="ttname"><a href="group__comm__routines.html#gaee85762f67e58df275a10d7bececf940">TIGLCommunicationRecvTaggedMPICommandfromDev</a></div><div class="ttdeci">int_fast32_t TIGLCommunicationRecvTaggedMPICommandfromDev(uint8_t *rxBuf, int tag, int dev, int count)</div><div class="ttdoc">Receives a message with any tag from any source. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationRx.cpp:193</div></div>
<div class="ttc" id="group__comm__routines_html_gab922207328e48b4acef99280809a1475"><div class="ttname"><a href="group__comm__routines.html#gab922207328e48b4acef99280809a1475">TIGLCommunicationExistTaggedMessageFromDev</a></div><div class="ttdeci">bool TIGLCommunicationExistTaggedMessageFromDev(int tag, uint_fast32_t dev, int_fast32_t *messageSize)</div><div class="ttdoc">checks if there exist messages with a given tag from a given source </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMonitor.cpp:160</div></div>
<div class="ttc" id="group__comm__routines_html_gad699725401268bd630f50e0a38823ee4"><div class="ttname"><a href="group__comm__routines.html#gad699725401268bd630f50e0a38823ee4">TIGLCommunicationRecvTaggedMPICommand</a></div><div class="ttdeci">int_fast32_t TIGLCommunicationRecvTaggedMPICommand(uint8_t *rxBuf, int tag)</div><div class="ttdoc">Receives a message with any tag from any source. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationRx.cpp:165</div></div>
<div class="ttc" id="group__comm__routines_html_gae9386ff69f95193aaeb3f10199979d07"><div class="ttname"><a href="group__comm__routines.html#gae9386ff69f95193aaeb3f10199979d07">TIGLCommunicationExistMessagesFromDev</a></div><div class="ttdeci">bool TIGLCommunicationExistMessagesFromDev(uint_fast32_t dev)</div><div class="ttdoc">Checks if there exist messages with any tag from a given source device. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMonitor.cpp:116</div></div>
<div class="ttc" id="group__comm__routines_html_gab848bd17d1170ed31806edb6bea1bd0c"><div class="ttname"><a href="group__comm__routines.html#gab848bd17d1170ed31806edb6bea1bd0c">TIGLCommunicationExistMessagesWithTag</a></div><div class="ttdeci">bool TIGLCommunicationExistMessagesWithTag(int tag)</div><div class="ttdoc">Checks if there exist messages with a given tag from any source. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMonitor.cpp:137</div></div>
<div class="ttc" id="group__comm__routines_html_gadf306c4991fc833186b65c8700815f74"><div class="ttname"><a href="group__comm__routines.html#gadf306c4991fc833186b65c8700815f74">TIGLCommunicationExistMessages</a></div><div class="ttdeci">bool TIGLCommunicationExistMessages()</div><div class="ttdoc">Checks if there exist messages from any source with any tag. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMonitor.cpp:70</div></div>
<div class="ttc" id="tiglCommunicationSysMessage_8hpp_html"><div class="ttname"><a href="tiglCommunicationSysMessage_8hpp.html">tiglCommunicationSysMessage.hpp</a></div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_a3647d597dc8f1678971485b7b8086279"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#a3647d597dc8f1678971485b7b8086279">TIGLCommunicationMessageDev::numTx</a></div><div class="ttdeci">uint_fast32_t numTx</div><div class="ttdoc">accumulative number of data message transmissions </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:128</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html">TIGLCommunicationMessageDev</a></div><div class="ttdoc">message container for TX/RX </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:116</div></div>
<div class="ttc" id="group__comm__routines_html_ga55203f293cf194bc1dde2803bdb77bb6"><div class="ttname"><a href="group__comm__routines.html#ga55203f293cf194bc1dde2803bdb77bb6">TIGLCommunicationSendMPICommandNonblocking</a></div><div class="ttdeci">int TIGLCommunicationSendMPICommandNonblocking(uint8_t *txBuf, uint_fast32_t bufSize, int_fast32_t dst, int tag, MPI_Request *req)</div><div class="ttdoc">Sends a non-blocking single message to a particular destination with a given tag. ...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationTx.cpp:77</div></div>
<div class="ttc" id="group__comm__routines_html_ga98daaa3a6811aa132b3eef033f518d40"><div class="ttname"><a href="group__comm__routines.html#ga98daaa3a6811aa132b3eef033f518d40">TIGLCommunicationWaitMPINonblocking</a></div><div class="ttdeci">int TIGLCommunicationWaitMPINonblocking(MPI_Request *req)</div><div class="ttdoc">Waits for nonblocking tx/rx. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMonitor.cpp:192</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_abce41176d7b2808b745c94d99f542c63"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#abce41176d7b2808b745c94d99f542c63">TIGLCommunicationMessageDev::TIGLCommunicationMessageDev</a></div><div class="ttdeci">TIGLCommunicationMessageDev()</div><div class="ttdoc">constructor </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:145</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_a02805f910460aa8cb91e81003089b045"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#a02805f910460aa8cb91e81003089b045">TIGLCommunicationMessageDev::numSysTx</a></div><div class="ttdeci">uint_fast32_t numSysTx</div><div class="ttdoc">accumulative number of system message transmissions </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:130</div></div>
<div class="ttc" id="structTIGLCommunicationMessageDev_html_a0ea7da2bd0e063ebc4572796f3bb7b0d"><div class="ttname"><a href="structTIGLCommunicationMessageDev.html#a0ea7da2bd0e063ebc4572796f3bb7b0d">TIGLCommunicationMessageDev::buf</a></div><div class="ttdeci">uint8_t buf[MAX_MESSAGE_SIZE]</div><div class="ttdoc">byte buffer for message storage </div><div class="ttdef"><b>Definition:</b> tiglCommunication.hpp:124</div></div>
<div class="ttc" id="group__comm__routines_html_ga263c63472be6e732331906559a138021"><div class="ttname"><a href="group__comm__routines.html#ga263c63472be6e732331906559a138021">TIGLCommunicationRecvMPICommand</a></div><div class="ttdeci">int TIGLCommunicationRecvMPICommand(uint8_t *rxBuf, uint_fast32_t bufSize, int_fast32_t src)</div><div class="ttdoc">Receives a message from a particular src with any tag. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationRx.cpp:56</div></div>
<div class="ttc" id="tiglCommunicationManager_8hpp_html"><div class="ttname"><a href="tiglCommunicationManager_8hpp.html">tiglCommunicationManager.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:51 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
